package xxx.oracle.apps.inv.rcv.server;

import java.awt.TextField;

import java.sql.Connection;
import java.sql.SQLException;

import java.util.Hashtable;

import java.util.StringTokenizer;

import oracle.apps.fnd.common.AppsContext;
import oracle.apps.fnd.flexj.FlexException;
import oracle.apps.inv.lov.server.*;
import oracle.apps.inv.rcv.server.*;
import oracle.apps.inv.utilities.server.DualUOMFields;
import oracle.apps.inv.utilities.server.NumberFieldBean;
import oracle.apps.inv.utilities.server.UtilFns;
import oracle.apps.mwa.beans.ButtonFieldBean;
import oracle.apps.mwa.beans.DescriptiveFlexFieldBean;
import oracle.apps.mwa.beans.TextFieldBean;
import oracle.apps.mwa.container.MWALib;
import oracle.apps.mwa.container.Session;
import oracle.apps.mwa.eventmodel.*;

// Referenced classes of package xxx.oracle.apps.inv.rcv.server:
//            xxxExtRcptGenFListener

public class xxxRcptGenPage extends RcptGenPage
{
    protected Connection conn;
    public DualUOMFields duomFields;
    public ButtonFieldBean mAddWeightBtn;
    xxxRcptGenFListener xxx;

    TextFieldBean mItemWeightField;
    public xxxRcptGenPage(Session s)
    {
        super(s);
        initCustomPage(s);
    }

    protected void addFields(MWAEvent mwaevent)
    {
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenPage.addFields");
        //Session session = mwaevent.getSession();
        super.addFields(mwaevent);
        //addFieldBean(mItemWeightFld);
        if(UtilFns.isTraceOn)
            UtilFns.trace("RCV: xxxRcptGenPage.addFields - complete");
    }

    
    protected void initPrompts(Session ses)
    {
        super.initPrompts(ses);
    }
     
    protected void setOSPPrompts(Session ses)
    {
        super.setOSPPrompts(ses);
    }

    public void pageEntered(MWAEvent e)
        throws DefaultOnlyHandlerException, InterruptedHandlerException, AbortHandlerException
    {
        super.pageEntered(e);
        //Add new Field
        mItemWeightField = new TextFieldBean();
        mItemWeightField.setName("XX.IWEIGHT");
        mItemWeightField.setPrompt("Item Weight");
        addFieldBean(10,mItemWeightField);  
        mItemWeightField.setRequired(true);
        mItemWeightField.setHidden(true);
    } 

    public void initCustomPage(Session s)
    {
        UtilFns.trace("calling initCustomPage() in custom code");
        UtilFns.trace("xRCVGenPage: *** START initCustomPage(e) LOVS"); 
        String xas[] = {
            " ", "ORGID", "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.RCV.SHIPMENT_NUM", "RECEIPT", ""
        };
        mShipmentNumFld.setInputParameters(xas);
        String[] inputs =
          {" ","ORGID", "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.DOC_NUMBER", "RECEIPT","","","PO",""};    
        getDocFld().setInputParameters(inputs);
        mDocFld = new DOCLOV();          
        UtilFns.trace("xRCV: xxxRcptGenPage.startPO"); 
      
        UtilFns.trace("xRCV: xxxRcptGenPage.endPO");
        String xas1[] = {
             " ", "ORGID", "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.RCV.REQUISITION_NUM", "RECEIPT"
        };
        mReqNumFld.setInputParameters(xas1);   
        String xas5[] = {
            " ", "ORGID", "xxx.oracle.apps.inv.rcv.server.xxxRcptGenPage.INV.LOCATION"
        };
        getLocationFld().setInputParameters(xas5);
        UtilFns.trace("xRCVGenPage: *** END initCustomPage(e) LOVS");      
       
        xxx = new xxxRcptGenFListener();
        getDocFld().addListener(xxx);
        getPOLineNumFld().addListener(xxx);
        getItemFld().addListener(xxx);
        getSubFld().addListener(xxx);
        getUOMFld().addListener(xxx);
        getQtyFld().addListener(xxx);
        getLocFld().addListener(xxx);
        getReqNumFld().addListener(xxx);
        getNextItemBut().addListener(xxx);
        getLocationFld().addListener(xxx);
    }

    public void pageExited(MWAEvent e)
        throws DefaultOnlyHandlerException, InterruptedHandlerException, AbortHandlerException
    {
        super.pageExited(e);
    }

    public void specialKeyPressed(MWAEvent e)
        throws DefaultOnlyHandlerException, InterruptedHandlerException, AbortHandlerException
    {
        super.specialKeyPressed(e);
    }

    public void setNextLotSerialProps()
    {
        super.setNextLotSerialProps();
    }

    public ProjectLOV getProjectFld()
    {
        return super.getProjectFld();
    }

    public TaskLOV getTaskFld()
    {
        return super.getTaskFld();
    }

    public LPNLOV getLPNFld()
    {
        return super.getLPNFld();
    }

    public LPNLOV getFromLPNFld()
    {
        return super.getFromLPNFld();
    }

    public DescField getCrossRefItemFld()
    {
        return super.getCrossRefItemFld();
    }

    public DescField getVendorItemFld()
    {
        return super.getVendorItemFld();
    }

    public DescField getSubstituteItemFld()
    {
        return super.getSubstituteItemFld();
    }

    public DescField getItemDescFld()
    {
        return super.getItemDescFld();
    }
    
    public RevisionLOV getRevFld()
    {
        return super.getRevFld();
    }

    public LocationLOV getLocationFld()
    {
        return super.getLocationFld();
    }

    public CountryLOV getCountryFld()
    {
        return super.getCountryFld();
    }

    public JobLOV getJobFld()
    {
        return super.getJobFld();
    }

    public DescField getWipLine()
    {
        return super.getWipLine();
    }

    public DescField getOpSeqNum()
    {
        return super.getOpSeqNum();
    }

    public DescField getDept()
    {
        return super.getDept();
    }

    public NumberFieldBean getRequiredQty()
    {
        return super.getRequiredQty();
    }

    public RcvButton getNextItemBut()
    {
        return super.getNextItemBut();
    }

    public RcvButton getDeliverBut()
    {
        return super.getDeliverBut();
    }

    public RcvButton getDoneBut()
    {
        return super.getDoneBut();
    }

    public RcvButton getCancelBut()
    {
        return super.getCancelBut();
    }    

    public SubinventoryLOV getSubFld()
    {
        return super.getSubFld();
    }

    public LocatorKFF getLocFld()
    {
        return super.getLocFld();
    }

    public String getTransactionTempID()
    {
        return super.getTransactionTempID();
    }

    public String getProductTransactionID()
    {
        return super.getProductTransactionID();
    }

    public void setProductTransactionID(String pTxnId)
    {
        super.setProductTransactionID(pTxnId);
    }

    public DescriptiveFlexFieldBean getDffFld()
    {
        return super.getDffFld();
    }

    public boolean processLot(MWAEvent e)
    {
        return super.processLot(e);
    }

    public boolean processSerial(MWAEvent e)
    {
        try {
            return super.processSerial(e);
        } catch (Exception f) {
            // TODO
             UtilFns.trace("calling processSerial(MWAEvent e) SQLException f");
             return false;
        }

    }
    
    /*
     * Kyle Thomas
     * 
     * Created new text field to hold the ITEM WEIGHT from
     * MTL_SYSTEM_ITEMS_B table based off of the 
     * Item number
     * 
     */
    public TextFieldBean getItemWeightField()
    {
        return mItemWeightField;
    }  
    /*
     * Kyle Thomas
     * 
     * This is the method that sets the value
     * in the above TextFieldBean
     * 
     */    
    public void setmWeight(MWAEvent mwaevent, TextFieldBean mTextBean, String mItemWeight) throws AbortHandlerException
    {
        UtilFns.trace("xxCustomTestPage:setmWeight START");        
        if (mItemWeight.matches("0.0")){
            mItemWeightField.setValue(""); 
        } else {
            mItemWeightField.setValue(mItemWeight);
        }
        mItemWeightField.setEditable(true);
    }    
    
    public TextFieldBean getWeight() 
    {
        return mItemWeightField;
    }
    
    public String getSrcSrlCtl(MWAEvent e, String aTransType)
        throws AbortHandlerException
    {
        return super.getSrcSrlCtl(e, aTransType);
    }

    public boolean processLotInterface(MWAEvent e)
    {
        return super.processLotInterface(e);
    }

    public boolean processSerialInterface(MWAEvent e)
    {
        return super.processSerialInterface(e);
    }
            
}